/******************************************************************************
 * Include perfisis.h - Common definitions for ISIS performance tool
 *
 * Written:	 05/14/91 by John H. Lee
 * Last Changed: 06/19/91 by John H. Lee
 * Version:	 0.3
 ******************************************************************************
 * Revisions:
 *   0.1  05/14/91 JHL Initial Creation
 *   0.2  06/10/91 JHL Added ENTRY_JUSTREPLY
 *   0.3  06/19/91 JHL Added PerfserverDM stuff
 *****************************************************************************/

#ifndef	_PERFISIS_H_
#define	_PERFISIS_H_


/*** Configuration Constants ***/

#define	PERFPORTNO	0	/* ISIS port no				*/
				/* ISIS server group name		*/
#define	PERFSERVNAME	"/isis/perfisis"


/*** Perfserver Entry Points ***/

#define	ENTRY_NOTHING	1	/* Does nothing.  Doesn't even reply	*/
#define	ENTRY_JUSTREPLY	2	/* Just reply				*/
#define	ENTRY_TRANSABCAST 3	/* Transactions using ABCast		*/
#define	ENTRY_TRANSTOKEN  4	/* Transactions using Token Passing	*/
#define	ENTRY_TRANSQUORUM 5	/* Transactions using Quorum Agreement	*/


/*** Return codes  ***/

#define	RET_OK		1	/* Operation success			*/
#define	RET_NOGROUP	2	/* Group required for op. not found	*/

#endif	_PERFISIS_H_
/* DON'T ADD ANYTHING AFTER THIS #endif */

/**************************** End of perfisis.h *****************************/
